var http = require('http');
var fs = require('fs');

http.createServer(function (req, res) {
  console.log("req : " + req.url);
  if (req.url == "/favicon.ico") {
    res.end();
  }
  else if (req.url.endsWith("controllee_1.html")) {
    fs.readFile("foo/controllee_1.html", function (err, data) {
      res.writeHead(200, { 'Content-Type': 'text/html' });
      res.write(data);
      res.end();
    });
  }
  else if (req.url.endsWith("controllee_2.html")) {
    fs.readFile("bar/controllee_2.html", function (err, data) {
      res.writeHead(200, { 'Content-Type': 'text/html' });
      res.write(data);
      res.end();
    });
  }
  else if (req.url.endsWith("service_worker_1.js")) {
    fs.readFile("foo/service_worker_1.js", function (err, data) {
      res.writeHead(200, { 'Content-Type': 'text/javascript' });
      res.write(data);
      res.end();
    });
  }
  else if (req.url.endsWith("service_worker_2.js")) {
    fs.readFile("bar/service_worker_2.js", function (err, data) {
      res.writeHead(200, { 'Content-Type': 'text/javascript' });
      res.write(data);
      res.end();
    });
  }
  else {
    if(fs.existsSync(req.url.slice(1))) {
      fs.readFile(req.url.slice(1), function (err, data) {
        if (req.url.endsWith(".js")) {
          res.writeHead(200, { 'Content-Type': 'text/javascript' });
        } else {
          res.writeHead(200, { 'Content-Type': 'text/html' });
        }
        res.write(data);
        res.end();
      });
    } else {
      console.log("====== warning ======");
      console.log("req for " + req.url + " respond with 404 error");
      console.log("=====================");
      res.writeHead(404, {"Content-Type": "text/html"});
      res.write(`
        <body>
          404 Not Found
        </body>
      `);
      res.end();
    }
  }
}).listen(8000, "0.0.0.0");